Index: /trunk/src/sh_suidchk.c
===================================================================
--- /trunk/src/sh_suidchk.c	(revision 584)
+++ /trunk/src/sh_suidchk.c	(revision 1)
@@ -1069,325 +461,427 @@
 	continue;
 
-      dirlist = addto_sh_dirlist (thisEntry, dirlist);
-    }
-
-  } while (thisEntry != NULL);
-
-  SH_MUTEX_UNLOCK(mutex_readdir);
-
-  closedir(thisDir);
-
-  dirlist_orig = dirlist;
-
-  sl_status = SL_ENONE;
-
-  do {
-
-    /* If the directory is empty, dirlist = NULL
-     */
-    if (!dirlist)
-      break;
-
-    if (sig_urgent > 0) {
-      SL_RETURN( (0), _("sh_suidchk_check_internal"));
-    }
-
-    tmpcat = SH_ALLOC(PATH_MAX);
-    (void) sl_strlcpy(tmpcat, iname, PATH_MAX);
-    
-    if ((sl_strlen(tmpcat) != sl_strlen(iname)) || (tmpcat[0] == '\0'))
-      {
+      tmpcat = SH_ALLOC(PATH_MAX);
+      (void) sl_strlcpy(tmpcat, iname, PATH_MAX);
+
+      if ((sl_strlen(tmpcat) != sl_strlen(iname)) || (tmpcat[0] == '\0'))
 	sl_status = SL_ETRUNC;
-      }
-    else
-      {
-	if (tmpcat[1] != '\0') 
-	  sl_status = sl_strlcat(tmpcat, "/",                 PATH_MAX);
-      }
-
-    if (! SL_ISERROR(sl_status))
-      sl_status = sl_strlcat(tmpcat, dirlist->sh_d_name,   PATH_MAX);
-
-    if (SL_ISERROR(sl_status))
-      {
-	tmp = sh_util_safe_name(tmpcat);
-	SH_MUTEX_LOCK(mutex_thread_nolog);
-	sh_error_handle ((-1), FIL__, __LINE__, (int) sl_status, 
-			 MSG_E_SUBGPATH,
-			 _("path too long"),
-			 _("sh_suidchk_check_internal"), tmp );
-	SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	SH_FREE(tmp);
-	SH_FREE(tmpcat);
-	dirlist = dirlist->next;
-	continue;
-      }
-
-    ++FileLimNum;
-    ++FileLimTotal;
-
-    /* Rate limit (Fps == Files per second)
-     */
-    if ((ShSuidchkFps > 0 && FileLimNum > ShSuidchkFps) &&
-	(ShSuidchkYield == S_FALSE))
-      {
-	FileLimNum  = 0;
-	FileLimNow  = time(NULL);
-	
-	if ( (FileLimNow  - FileLimStart) > 0 && 
-	     FileLimTotal/(FileLimNow  - FileLimStart) > ShSuidchkFps )
-	  (void) retry_msleep((int)((FileLimTotal/(FileLimNow-FileLimStart))/
-				    ShSuidchkFps) , 0);
-      }
-
-    status = (int) retry_lstat(FIL__, __LINE__, tmpcat, &buf);
-
-    if (status != 0)
-      {
-	volatile int elevel = SH_ERR_ERR;
-	size_t tlen;
-
-	status = errno;
-	tmp = sh_util_safe_name(tmpcat);
-	tlen = strlen(tmp);
-	if (tlen >= 6 && 0 == strcmp(&tmp[tlen-6], _("/.gvfs")))
-	  elevel = SH_ERR_NOTICE;
-	else if (tlen >= 5 && 0 == strcmp(&tmp[tlen-5], _("/gvfs")))
-	  elevel = SH_ERR_NOTICE;
-
-        /* If we are scanning a temporary directory where dirs and files
-	 * can be created/deleted, an lstat() error is something which
-	 * may occur frequently. As a missing dir/file is not an important
-	 * problem for the suidcheck, the error level is only SH_ERR_NOTICE. 
-	 */
-        if (status == ENOENT)
-          elevel = SH_ERR_NOTICE;
-
-	SH_MUTEX_LOCK(mutex_thread_nolog);
-	sh_error_handle (elevel, FIL__, __LINE__, status, MSG_ERR_LSTAT,
-			 sh_error_message(status, errbuf, sizeof(errbuf)),
-			 tmp );
-	SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	SH_FREE(tmp);
-      }
-    else
-      {
-	if (/*@-usedef@*/S_ISDIR(buf.st_mode)/*@+usedef@*/ &&
-	    (ShSuidchkExclude == NULL || 
-	     NULL == zAVL_string_get(ShSuidchkExclude, tmpcat)))
-	  {
-	    /* fs is a STATIC string or NULL
-	     */
-	    fs = filesystem_type (tmpcat, tmpcat, &buf);
-
-	    if (fs != NULL 
-#ifndef SH_SUIDTESTDIR
-		&& 
-		0 != strncmp (_("afs"),     fs, 3) && 
-		0 != strncmp (_("devfs"),   fs, 5) &&
-		0 != strncmp (_("fdesc"),   fs, 5) &&
-		0 != strncmp (_("iso9660"), fs, 7) &&
-		0 != strncmp (_("cd9660"),  fs, 6) &&
-		0 != strncmp (_("lustre"),  fs, 6) &&
-		0 != strncmp (_("mmfs"),    fs, 4) && 
-		0 != strncmp (_("msdos"),   fs, 5) &&
-		0 != strncmp (_("nfs"),     fs, 3) &&
-		0 != strncmp (_("proc"),    fs, 4) &&
-		0 != strncmp (_("sysfs"),   fs, 5) &&
-		0 != strncmp (_("vfat"),    fs, 4)
-#endif 
-		)
-	      {
-		if ((ShSuidchkNosuid == S_TRUE) || 
-		    (0 != strncmp (_("nosuid"),  fs, 6)))
+      else
+	{
+	  if (tmpcat[1] != '\0') 
+	    sl_status = sl_strlcat(tmpcat, "/",                 PATH_MAX);
+	}
+      if (! SL_ISERROR(sl_status))
+	sl_status = sl_strlcat(tmpcat, thisEntry->d_name,   PATH_MAX);
+      if (SL_ISERROR(sl_status))
+	{
+	  tmp = sh_util_safe_name(tmpcat);
+	  sh_error_handle ((-1), FIL__, __LINE__, (int) sl_status, 
+			   MSG_E_SUBGPATH,
+			   _("path too long"),
+			   _("sh_suidchk_check_internal"), tmp );
+	  SH_FREE(tmp);
+	  continue;
+	}
+
+      ++FileLimNum;
+      ++FileLimTotal;
+
+      if ((ShSuidchkFps > 0 && FileLimNum > ShSuidchkFps && FileLimTotal > 0)&&
+	  (ShSuidchkYield == S_FALSE))
+	{
+	  FileLimNum  = 0;
+	  FileLimNow  = time(NULL);
+ 
+	  if ( (FileLimNow  - FileLimStart) > 0 && 
+	       FileLimTotal/(FileLimNow  - FileLimStart) > ShSuidchkFps )
+	    (void) retry_msleep((int)((FileLimTotal/(FileLimNow-FileLimStart))/
+		   ShSuidchkFps) , 0);
+	}
+	      
+      status = (int) retry_lstat(FIL__, __LINE__, tmpcat, &buf);
+
+      if (status != 0)
+	{
+	  status = errno;
+	  tmp = sh_util_safe_name(tmpcat);
+	  sh_error_handle (SH_ERR_ERR, FIL__, __LINE__, status, MSG_ERR_LSTAT,
+			   sh_error_message(status),
+			   tmpcat );
+	  SH_FREE(tmp);
+	}
+      else
+	{
+	  if (/*@-usedef@*/S_ISDIR(buf.st_mode)/*@+usedef@*/ &&
+	      (ShSuidchkExclude == NULL || 
+	      0 != strncmp(tmpcat, ShSuidchkExclude, (size_t) ExcludeLen)))
+	    {
+	      /* fs is a STATIC string
+	       */
+	      fs = filesystem_type (tmpcat, tmpcat, &buf);
+	      if (fs != NULL && 
+		  0 != strncmp (_("nfs"),     fs, 3) && 
+		  0 != strncmp (_("proc"),    fs, 4) &&
+		  0 != strncmp (_("iso9660"), fs, 7) &&
+		  0 != strncmp (_("vfat"),    fs, 4) &&
+		  0 != strncmp (_("msdos"),   fs, 5) &&
+		  0 != strncmp (_("devfs"),   fs, 5) &&
+		  0 != strncmp (_("nosuid"),  fs, 6) 
+		  )
+		{
 		  /* fprintf(stderr, "%s: %s\n", fs, tmpcat); */
 		  (void) sh_suidchk_check_internal(tmpcat);
-	      }
-	  }
-	else if (S_ISREG(buf.st_mode) &&
-		 (0 !=(S_ISUID & buf.st_mode) ||
+		}
+	    }
+	  else if (S_ISREG(buf.st_mode) &&
+		   (0 !=(S_ISUID & buf.st_mode) ||
 #if defined(HOST_IS_LINUX)
-		  (0 !=(S_ISGID & buf.st_mode) && 
-		   0 !=(S_IXGRP & buf.st_mode)) 
+		    (0 !=(S_ISGID & buf.st_mode) && 
+		     0 !=(S_IXGRP & buf.st_mode)) 
 #else  
-		  0 !=(S_ISGID & buf.st_mode)
-#endif
-		  )
-		 )
-	  {
-	    int dummy;
-	    int class;
-	    unsigned long check_flags = 0;
-
-	    theFile = SH_ALLOC(sizeof(file_type));
-
-	    (void) sl_strlcpy (theFile->fullpath, tmpcat, PATH_MAX);
-	    theFile->check_flags  = sh_files_maskof(SH_LEVEL_READONLY);
-	    CLEAR_SH_FFLAG_REPORTED(theFile->file_reported);
-	    theFile->attr_string = NULL;
-	    theFile->link_path   = NULL;
-	    
-	    sh_files_search_file(tmpcat, &class,  &check_flags, &dummy);
-	    if ((check_flags & MODI_PREL) != 0)
-	      MODI_SET(theFile->check_flags, MODI_PREL);
-
-	    status = sh_unix_getinfo (ShDFLevel[SH_ERR_T_RO], 
-				      dirlist->sh_d_name,
-				      theFile, fileHash, 0);
-	    
-	    tmp = sh_util_safe_name(tmpcat);
-	    
-	    if (status != 0)
-	      {
-		SH_MUTEX_LOCK(mutex_thread_nolog);
-		sh_error_handle (ShSuidchkSeverity, FIL__, __LINE__, 
-				 0, MSG_E_SUBGPATH,
-				 _("Could not check suid/sgid file"),
-				 _("sh_suidchk_check_internal"),
-				 tmp);
-		SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	      }
-	    else
-	      {
-		
-		if ( sh.flag.update   == S_TRUE && 
-		     (sh.flag.checkSum == SH_CHECK_INIT  || 
-		      sh.flag.checkSum == SH_CHECK_CHECK))
-		  {
-		    int compret;
-
-		    /* Updating database. Report new files that
-		     * are not in database already. Then compare
-		     * to database and report changes.
-		     */
-		    if (-1 == sh_hash_have_it (tmpcat))
-		      {
-			SH_MUTEX_LOCK(mutex_thread_nolog);
-			sh_error_handle ((-1), FIL__, __LINE__, 
-					 0, MSG_SUID_FOUND, tmp );
-			SH_MUTEX_UNLOCK(mutex_thread_nolog);
-		      }
-		    else
-		      {
-			SH_MUTEX_LOCK(mutex_thread_nolog);
-			sh_error_handle (SH_ERR_ALL, FIL__, __LINE__, 
-					 0, MSG_SUID_FOUND, tmp );
-			SH_MUTEX_UNLOCK(mutex_thread_nolog);
-		      }
-		    
-		    SH_MUTEX_LOCK(mutex_thread_nolog);
-		    compret = sh_hash_compdata (SH_LEVEL_READONLY, 
-						theFile, fileHash,
-						_("[SuidCheck]"), 
-						ShSuidchkSeverity);
-		    SH_MUTEX_UNLOCK(mutex_thread_nolog);
-
-		    if (compret == 0)
-		      {
-			sh_hash_pushdata_memory (theFile, fileHash); /* no call to sh_error_handle */
-		      }
-		    
-		    sh_hash_set_flag(tmpcat, SH_FFLAG_SUIDCHK); /* no call to sh_error_handle */
-		    
-		  }
-		
-		else if (sh.flag.checkSum == SH_CHECK_INIT  && 
-			 sh.flag.update == S_FALSE )
-		  {
-		    /* Running init. Report on files detected.
-		     */
-		    sh_dbIO_rootfs_strip(theFile->fullpath);
-		    sh_dbIO_data_write (theFile, fileHash); /* no call to sh_error_handle */
-		    SH_MUTEX_LOCK(mutex_thread_nolog);
-		    sh_error_handle ((-1), FIL__, __LINE__, 
-				     0, MSG_SUID_FOUND, tmp );
-		    SH_MUTEX_UNLOCK(mutex_thread_nolog);
-		  }
-		
-		else if (sh.flag.checkSum == SH_CHECK_CHECK )
-		  {
-		    /* Running file check. Report on new files
-		     * detected, and quarantine them.
-		     */
-		    SH_MUTEX_LOCK(mutex_thread_nolog);
-		    sh_error_handle (SH_ERR_ALL, FIL__, __LINE__, 
-				     0, MSG_SUID_FOUND, tmp );
-		    SH_MUTEX_UNLOCK(mutex_thread_nolog);
-		    
-		    fflags = sh_hash_getflags(tmpcat); /* no call to sh_error_handle */
-		    
-		    if ( (-1 == fflags) || (!SH_FFLAG_SUIDCHK_SET(fflags)))
-		      {
-			if (-1 == fflags)
-			  {
-			    (void) sh_unix_gmttime (theFile->ctime, timestrc, sizeof(timestrc)); 
-			    (void) sh_unix_gmttime (theFile->atime, timestra, sizeof(timestra)); 
-			    (void) sh_unix_gmttime (theFile->mtime, timestrm, sizeof(timestrm));
-
-			    report_file(tmpcat, theFile, timestrc, timestra, timestrm);
-			  }
-			/* Quarantine file according to configured method
-			 */
-			if (ShSuidchkQEnable == S_TRUE)
-			  {
-			    switch (ShSuidchkQMethod)
-			      {
-			      case SH_Q_DELETE:
-				sh_q_delete(theFile->fullpath);
-				break;
-			      case SH_Q_CHANGEPERM:
-				sh_q_changeperm(theFile->fullpath);
-				break;
-			      case SH_Q_MOVE:
-				sh_q_move(theFile->fullpath, theFile, timestrc, timestra, timestrm);
-				break;
-			      default:
-				SH_MUTEX_LOCK(mutex_thread_nolog);
-				sh_error_handle (ShSuidchkSeverity, FIL__,
-						 __LINE__, 0, MSG_SUID_QREPORT,
-						 _("Bad quarantine method"), tmp);
-				SH_MUTEX_UNLOCK(mutex_thread_nolog);
-				break;
-			      }
-			  }
-			else
-			  {
-			    /* 1.8.1 push file to in-memory database
-			     */
-			    SH_MUTEX_LOCK(mutex_thread_nolog);
-			    (void) sh_hash_compdata (SH_LEVEL_READONLY,
-						     theFile, fileHash,
-						     _("[SuidCheck]"),
-						     ShSuidchkSeverity);
-			    SH_MUTEX_UNLOCK(mutex_thread_nolog);
-			    
-			    sh_hash_set_flag(tmpcat, SH_FFLAG_SUIDCHK); /* no call to sh_error_handle */
-			    
-			  }
-		      }
-		    else
-		      {
-			/* File exists. Check for modifications.
-			 */
-			SH_MUTEX_LOCK(mutex_thread_nolog);
-			(void) sh_hash_compdata (SH_LEVEL_READONLY, 
-						 theFile, fileHash,
-						 _("[SuidCheck]"),
-						 ShSuidchkSeverity);
-			SH_MUTEX_UNLOCK(mutex_thread_nolog);	
-			sh_hash_set_flag(tmpcat, SH_FFLAG_SUIDCHK); /* no call to sh_error_handle */
-			
-		      }
-		  }
-	      }
-	    SH_FREE(tmp);
-	    if (theFile->attr_string) SH_FREE(theFile->attr_string);
-	    if (theFile->link_path)   SH_FREE(theFile->link_path);
-	    SH_FREE(theFile);
-	  }
-      }
-    SH_FREE(tmpcat);
-
-  
+		    0 !=(S_ISGID & buf.st_mode)
+#endif
+		    )
+		   )
+	    {
+	      
+	      (void) sl_strlcpy (theFile.fullpath, tmpcat, PATH_MAX);
+	      theFile.check_mask = sh_files_maskof(SH_LEVEL_READONLY);
+	      theFile.reported   = S_FALSE;
+	      status = sh_unix_getinfo (ShDFLevel[SH_ERR_T_RO], 
+					thisEntry->d_name,
+					&theFile, fileHash, 0);
+
+	      tmp = sh_util_safe_name(tmpcat);
+
+	      if (status != 0)
+		{
+		  sh_error_handle (ShSuidchkSeverity, FIL__, __LINE__, 
+				   0, MSG_E_SUBGPATH,
+				   _("Could not check suid/sgid file"),
+				   _("sh_suidchk_check_internal"),
+				   tmp);
+		}
+	      else
+		{
+		  if (sh.flag.update == S_TRUE && 
+		      (sh.flag.checkSum == SH_CHECK_INIT  || 
+		       sh.flag.checkSum == SH_CHECK_CHECK))
+		    {
+		      if (-1 == sh_hash_have_it (tmpcat))
+			{
+			  sh_error_handle ((-1), FIL__, __LINE__, 
+					   0, MSG_SUID_FOUND,
+					   tmp );
+			}
+		      else
+			{
+			  sh_error_handle (SH_ERR_ALL, FIL__, __LINE__, 
+					   0, MSG_SUID_FOUND,
+					   tmp );
+			}
+		      if (0 == sh_hash_compdata (SH_LEVEL_READONLY, 
+						 &theFile, fileHash,
+						 _("[SuidCheck]"), 
+						 ShSuidchkSeverity))
+			{
+			  sh_hash_pushdata_memory (&theFile, fileHash);
+			}
+		    }
+		  else if (sh.flag.checkSum == SH_CHECK_INIT  && 
+			   sh.flag.update == S_FALSE )
+		    {
+		      sh_hash_pushdata (&theFile, fileHash);
+		      sh_error_handle ((-1), FIL__, __LINE__, 
+				       0, MSG_SUID_FOUND,
+				       tmp );
+		    }
+		  else if (sh.flag.checkSum == SH_CHECK_CHECK )
+		    {
+		      sh_error_handle (SH_ERR_ALL, FIL__, __LINE__, 
+				       0, MSG_SUID_FOUND,
+				       tmp );
+		      if (-1 == sh_hash_have_it (tmpcat))
+			{
+			  msg = SH_ALLOC(SH_BUFSIZE);
+			  msg[0] = '\0';
+			  /*@-usedef@*/
+			  (void) sl_strlcpy (timestrc, 
+					     sh_unix_gmttime (theFile.ctime), 
+					     32);
+			  (void) sl_strlcpy (timestra, 
+					     sh_unix_gmttime (theFile.atime), 
+					     32);
+			  (void) sl_strlcpy (timestrm, 
+					     sh_unix_gmttime (theFile.mtime), 
+					     32);
+#ifdef SH_USE_XML
+			  (void) sl_snprintf(msg, SH_BUFSIZE, _("owner_new=\"%s\" iowner_new=\"%ld\" group_new=\"%s\" igroup_new=\"%ld\" size_new=\"%lu\" ctime_new=\"%s\" atime_new=\"%s\" mtime_new=\"%s\""), 
+				      theFile.c_owner, theFile.owner, 
+				      theFile.c_group, theFile.group, 
+				      (unsigned long) theFile.size, 
+				      timestrc, timestra, timestrm);
+#else
+			  (void) sl_snprintf(msg, SH_BUFSIZE, _("owner_new=<%s>, iowner_new=<%ld>, group_new=<%s>, igroup_new=<%ld>, filesize=<%lu>, ctime=<%s>, atime=<%s>, mtime=<%s>"), 
+				      theFile.c_owner, theFile.owner, 
+				      theFile.c_group, theFile.group, 
+				      (unsigned long) theFile.size, 
+				      timestrc, timestra, timestrm);
+#endif
+			  /*@+usedef@*/
+
+			  sh_error_handle (ShSuidchkSeverity, FIL__, __LINE__, 
+					   0, MSG_SUID_POLICY,
+					   _("suid/sgid file not in database"),
+					   tmp, msg );
+			  SH_FREE(msg);
+
+			  /* Quarantine file according to configured method
+                          */
+			  if (ShSuidchkQEnable == S_TRUE)
+			    {
+			      switch (ShSuidchkQMethod)
+				{
+				  case SH_Q_DELETE:
+				    /* if (unlink (theFile.fullpath) == -1) */
+				    if (do_truncate (theFile.fullpath) == -1)
+				      {
+					status = errno;
+					msg = SH_ALLOC(SH_BUFSIZE);
+					(void) sl_snprintf(msg, SH_BUFSIZE, _("Problem quarantining file.  File NOT quarantined.  errno = %ld"), status);
+					sh_error_handle (ShSuidchkSeverity,
+							 FIL__, __LINE__, 
+							 status,
+							 MSG_SUID_QREPORT, msg,
+							 tmp );
+					SH_FREE(msg);
+				      }
+				    else
+				      {
+				        sh_error_handle (ShSuidchkSeverity,
+							 FIL__, __LINE__, 0,
+							 MSG_SUID_QREPORT,
+							 _("Quarantine method applied"),
+							 tmp );
+				      }
+				    break;
+				  case SH_Q_CHANGEPERM:
+				    if (retry_lstat(FIL__, __LINE__, tmpcat, &fileInfo) == -1)
+				      {
+					status = errno;
+					msg = SH_ALLOC(SH_BUFSIZE);
+					(void) sl_snprintf(msg, SH_BUFSIZE, _("I/O error.  errno = %ld"), status);
+					sh_error_handle (ShSuidchkSeverity,
+							 FIL__, __LINE__, 
+							 status,
+							 MSG_SUID_QREPORT, msg,
+							 tmp );
+					SH_FREE(msg);
+				      }
+				    else
+				      {
+					if (0 != (caperr = sl_get_cap_qdel()))
+					  {
+					    sh_error_handle((-1), FIL__, __LINE__, 
+							    caperr, MSG_E_SUBGEN,
+							    sh_error_message (caperr), 
+							    _("sl_get_cap_qdel"));
+					  }
+
+					if ((fileInfo.st_mode & S_ISUID) > 0)
+					  fileInfo.st_mode -= S_ISUID;
+					if ((fileInfo.st_mode & S_ISGID) > 0)
+					  fileInfo.st_mode -= S_ISGID;
+					if (chmod(tmpcat, fileInfo.st_mode) == -1)
+					  {
+					    status = errno;
+					    msg = SH_ALLOC(SH_BUFSIZE);
+					    (void) sl_snprintf(msg, SH_BUFSIZE, _("Problem quarantining file.  File NOT quarantined.  errno = %ld"), status);
+					    sh_error_handle (ShSuidchkSeverity,
+							     FIL__, __LINE__, 
+							     status,
+							     MSG_SUID_QREPORT,
+							     msg, tmp );
+					    SH_FREE(msg);
+					  }
+					else
+					  {
+					    sh_error_handle (ShSuidchkSeverity,
+							     FIL__, __LINE__, 
+							     0,
+							     MSG_SUID_QREPORT,
+							     _("Quarantine method applied"),
+							     tmp );
+					  }
+					if (0 != (caperr = sl_drop_cap_qdel()))
+					  {
+					    sh_error_handle((-1), FIL__, __LINE__, 
+							    caperr, MSG_E_SUBGEN,
+							    sh_error_message (caperr), 
+							    _("sl_drop_cap_qdel"));
+					  }
+				      }
+				    break;
+				  case SH_Q_MOVE:
+				    dir = SH_ALLOC(PATH_MAX+1);
+				    (void) sl_strlcpy (dir, DEFAULT_QDIR, PATH_MAX+1);
+				    if (access (dir, F_OK) != 0)
+				      {
+					status = errno;
+					msg = SH_ALLOC(SH_BUFSIZE);
+					(void) sl_snprintf(msg, SH_BUFSIZE, _("Problem quarantining file.  File NOT quarantined.  errno = %ld (access)"), status);
+					sh_error_handle (ShSuidchkSeverity,
+							 FIL__, __LINE__, 
+							 status,
+							 MSG_SUID_QREPORT, msg,
+							 tmp );
+					SH_FREE(msg);
+				      }
+				    else
+				      {
+					if (retry_lstat (FIL__, __LINE__, 
+							theFile.fullpath, &fileInfo) == -1)
+					  {
+					    status = errno;
+					    msg = SH_ALLOC(SH_BUFSIZE);
+					    (void) sl_snprintf(msg, SH_BUFSIZE, _("I/O error.  errno = %ld(stat)"), status);
+					    sh_error_handle (ShSuidchkSeverity,
+							     FIL__, __LINE__, 
+							     status,
+							     MSG_SUID_QREPORT,
+							     msg, tmp );
+					    SH_FREE(msg);
+					  }
+					else
+					  {
+					    basetmp = SH_ALLOC(1 + sl_strlen(theFile.fullpath));
+					    (void) sl_strlcpy(basetmp, theFile.fullpath, 
+						       1 + sl_strlen(theFile.fullpath));
+					    filetmp = SH_ALLOC(PATH_MAX+1);
+					    (void) sl_snprintf(filetmp, PATH_MAX+1, "%s/%s", 
+							DEFAULT_QDIR, basename(basetmp));
+					    SH_FREE(basetmp);
+					    
+					    readFile  = open (theFile.fullpath, O_RDONLY);
+					    if (readFile != -1)
+					      writeFile = open (filetmp, O_WRONLY|O_CREAT);
+
+					    if ((readFile == -1) || (writeFile == -1))
+					      {
+						status = errno;
+						msg = SH_ALLOC(SH_BUFSIZE);
+						(void) sl_snprintf(msg, SH_BUFSIZE, _("Problem quarantining file.  File NOT quarantined.  errno = %ld (open)"), status);
+						sh_error_handle (ShSuidchkSeverity,
+								 FIL__, __LINE__, status,
+								 MSG_SUID_QREPORT,
+								 msg, tmp );
+						SH_FREE(msg);
+					      }
+					    else
+					      { 
+						/* sizeof(buffer) is 1024 */
+						while ((count = (int) read (readFile, buffer, sizeof (buffer))) > 0)
+						  if ((int) write (writeFile, buffer, (size_t) count) != count)
+						    {
+						      status = errno;
+						      msg = SH_ALLOC(SH_BUFSIZE);
+					    	      (void) sl_snprintf(msg, SH_BUFSIZE, _("I/O error.  errno = %ld (write)"), status);
+						      sh_error_handle (ShSuidchkSeverity,
+								       FIL__,
+								       __LINE__,
+								       status,
+								       MSG_SUID_QREPORT,
+								       msg, tmp );
+						      SH_FREE(msg);
+						    }
+					      }
+					    (void) close (readFile);
+					    (void) fchmod(writeFile, S_IRUSR | S_IWUSR | S_IXUSR);
+					    (void) close (writeFile);
+					    /* if (unlink (theFile.fullpath) == -1) */
+					    if (do_truncate (theFile.fullpath) == -1)
+					      {
+						status = errno;
+						msg = SH_ALLOC(SH_BUFSIZE);
+						(void) sl_snprintf(msg, SH_BUFSIZE, _("Problem quarantining file.  File NOT quarantined.  errno = %ld"), status);
+						sh_error_handle (ShSuidchkSeverity,
+								 FIL__, __LINE__, status,
+								 MSG_SUID_QREPORT,
+								 msg, tmp );
+						SH_FREE(msg);
+					      }
+					    else
+					      {
+						(void) sl_snprintf(filetmp, PATH_MAX+1, "%s/%s.info", 
+								   DEFAULT_QDIR, 
+								   basename(theFile.fullpath));
+						filePtr = fopen (filetmp, "w+");
+						/*@-usedef@*/
+						if (filePtr)
+						  {
+						    fprintf(filePtr, _("File Info:\n filename=%s\n size=%lu\n owner=%s(%d)\n group=%s(%d)\n ctime=%s\n atime=%s\n mtime=%s\n"), 
+							    theFile.fullpath, 
+							    (unsigned long) theFile.size, 
+							    theFile.c_owner, (int) theFile.owner, 
+							    theFile.c_group, (int) theFile.group, 
+							    timestrc, timestra, timestrm);
+						    (void) fclose (filePtr);
+						  }
+						/*@+usedef@*/
+					
+						sh_error_handle (ShSuidchkSeverity,
+							 	 FIL__,__LINE__,
+								 0, MSG_SUID_QREPORT,
+								 _("Quarantine method applied"),
+								 tmp );
+						if (chmod(filetmp, S_IRUSR | S_IWUSR) == -1)
+						  {
+						    status = errno;
+						    msg = SH_ALLOC(SH_BUFSIZE);
+						    (void) sl_snprintf(msg, SH_BUFSIZE, _("Problem setting permissions on quarantined file.  errno = %ld"), status);
+						    sh_error_handle (ShSuidchkSeverity,
+								     FIL__,__LINE__,
+								     status, MSG_SUID_QREPORT,
+								     msg, tmp );
+						    SH_FREE(msg);
+						  }
+					      }
+					    SH_FREE(filetmp);
+					  }
+				      }
+				    SH_FREE(dir);
+				    break;
+				  default:
+				    sh_error_handle (ShSuidchkSeverity, FIL__,
+						     __LINE__, 0, MSG_SUID_QREPORT,
+						     _("Bad quarantine method"),
+						     tmp);
+				    break;
+				}
+			    }
+			  else
+			    {
+			      /* 1.8.1 push file to in-memory database
+			       */
+			      (void) sh_hash_compdata (SH_LEVEL_READONLY,
+						       &theFile, fileHash,
+						       _("[SuidCheck]"),
+						       ShSuidchkSeverity);
+			    }
+			}
+		      else
+			{
+			  (void) sh_hash_compdata (SH_LEVEL_READONLY, 
+						   &theFile, fileHash,
+						   _("[SuidCheck]"),
+						   ShSuidchkSeverity);
+			}
+		    }
+		}
+	      SH_FREE(tmp);
+
+	    }
+	}
+      SH_FREE(tmpcat);
+    }
 #ifdef HAVE_SCHED_YIELD
     if (ShSuidchkYield == S_TRUE)
@@ -1396,20 +890,14 @@
 	  {
 	    status = errno;
-	    SH_MUTEX_LOCK(mutex_thread_nolog);
 	    sh_error_handle ((-1), FIL__, __LINE__, status, MSG_E_SUBGEN,
-			     _("Failed to release time slice"),
+		             _("Failed to release time slice"),
 			     _("sh_suidchk_check_internal") );
-	    SH_MUTEX_UNLOCK(mutex_thread_nolog);
+	    
 	  }
       }
 #endif
-  
-    dirlist = dirlist->next;
-
-  }  while (dirlist != NULL);
-
-
-  kill_sh_dirlist (dirlist_orig);
-
+  }  while (thisEntry != NULL);
+
+  (void) closedir (thisDir);
   SL_RETURN( (0), _("sh_suidchk_check_internal"));
 }
@@ -1420,28 +908,8 @@
  *
  *************/
-int sh_suidchk_init (struct mod_type * arg)
-{
-#ifndef HAVE_PTHREAD
-  (void) arg;
-#endif
-
+int sh_suidchk_init ()
+{
   if (ShSuidchkActive == S_FALSE)
-    return SH_MOD_FAILED;
-
-#ifdef HAVE_PTHREAD
-  if (arg != NULL && arg->initval < 0 &&
-      (sh.flag.isdaemon == S_TRUE || sh.flag.loop == S_TRUE))
-    {
-      if (0 == sh_pthread_create(sh_threaded_module_run, (void *)arg))
-	return SH_MOD_THREAD;
-      else
-	return SH_MOD_FAILED;
-    }
-  else if (arg != NULL && arg->initval == SH_MOD_THREAD &&
-	   (sh.flag.isdaemon == S_TRUE || sh.flag.loop == S_TRUE))
-    {
-      return SH_MOD_THREAD;
-    }
-#endif
+    return (-1);
 
   return (0);
@@ -1495,16 +963,11 @@
 int sh_suidchk_check ()
 {
-  volatile int status;
+  int status;
 
   SL_ENTER(_("sh_suidchk_check"));
 
-  if (ShSuidchkActive == S_FALSE)
-    SL_RETURN(-1, _("sh_suidchk_check"));
-
-  SH_MUTEX_LOCK(mutex_thread_nolog);
-  sh_error_handle (SH_ERR_INFO, FIL__, __LINE__, EINVAL, MSG_E_SUBGEN,
+  sh_error_handle (SH_ERR_NOTICE, FIL__, __LINE__, EINVAL, MSG_E_SUBGEN,
 		   _("Checking for SUID programs"),
-		   _("sh_suidchk_check") );
-  SH_MUTEX_UNLOCK(mutex_thread_nolog);
+		   _("suidchk_check") );
 
   FileLimNow        = time(NULL);
@@ -1513,15 +976,9 @@
   FileLimTotal      = 0;
 
-#ifdef SH_SUIDTESTDIR
-  status = sh_suidchk_check_internal (SH_SUIDTESTDIR);
-#else
   status = sh_suidchk_check_internal ("/");
-#endif
-
-  SH_MUTEX_LOCK(mutex_thread_nolog);
+
   sh_error_handle ((-1), FIL__, __LINE__, EINVAL, MSG_SUID_SUMMARY,
 		   FileLimTotal,
 		   (long) (time(NULL) - FileLimStart) );
-  SH_MUTEX_UNLOCK(mutex_thread_nolog);
 
   SL_RETURN(status, _("sh_suidchk_check"));
@@ -1534,5 +991,5 @@
  *************/
 
-int sh_suidchk_set_severity  (const char * c)
+int sh_suidchk_set_severity  (char * c)
 {
   int retval;
@@ -1546,9 +1003,7 @@
 }
 
-int sh_suidchk_set_exclude (const char * c)
-{
-  int ret = 0;
+int sh_suidchk_set_exclude (char * c)
+{
   SL_ENTER(_("sh_suidchk_set_exclude"));
-
   if (c == NULL || c[0] == '\0')
     {
@@ -1559,16 +1014,33 @@
     {
       if (ShSuidchkExclude != NULL)
-	sh_suid_exclude_free();
+	SH_FREE(ShSuidchkExclude);
+      ShSuidchkExclude = NULL;
       SL_RETURN(0, _("sh_suidchk_set_exclude"));
     }
 
-  ret = sh_suid_exclude_add(c);
-
-  SL_RETURN(ret, _("sh_suidchk_set_exclude"));
-}
-
-int sh_suidchk_set_timer (const char * c)
-{
-  volatile long val;
+  if (ShSuidchkExclude != NULL)
+    SH_FREE(ShSuidchkExclude);
+
+  /* 1.8.1 add trailing slash
+   */
+  ExcludeLen       = (int) sl_strlen(c);
+  if (c[ExcludeLen-1] != '/')
+    {
+      ExcludeLen++;
+      if ((ExcludeLen <= 0) || (ExcludeLen+1 <= 0)) /* may overflow */
+	{
+	  SL_RETURN(-1, _("sh_suidchk_set_exclude"));
+	}
+    }
+  ShSuidchkExclude = SH_ALLOC((size_t) ExcludeLen + 1);
+  (void) sl_strlcpy(ShSuidchkExclude, c, (size_t)(ExcludeLen + 1));
+  ShSuidchkExclude[ExcludeLen-1] = '/';
+
+  SL_RETURN(0, _("sh_suidchk_set_exclude"));
+}
+
+int sh_suidchk_set_timer (char * c)
+{
+  long val;
 
   SL_ENTER(_("sh_suidchk_set_timer"));
@@ -1576,10 +1048,7 @@
   val = strtol (c, (char **)NULL, 10);
   if (val <= 0)
-    {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
-      sh_error_handle ((-1), FIL__, __LINE__, EINVAL, MSG_EINVALS,
-		       _("suidchk timer"), c);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-    }
+    sh_error_handle ((-1), FIL__, __LINE__, EINVAL, MSG_EINVALS,
+                      _("suidchk timer"), c);
+
   val = (val <= 0 ? 7200 : val);
 
@@ -1589,5 +1058,5 @@
 
 
-static void sh_suidchk_free_schedule (void)
+int sh_suidchk_free_schedule ()
 {
   sh_schedule_t * current = ShSuidchkSched;
@@ -1601,17 +1070,8 @@
     }
   ShSuidchkSched = NULL;
-  return;
-}
-
-int sh_suidchk_reconf ()
-{
-  SH_MUTEX_LOCK(mutex_suid_check);
-  sh_suidchk_free_schedule();
-  set_defaults();
-  SH_MUTEX_UNLOCK(mutex_suid_check);
   return 0;
 }
 
-int sh_suidchk_set_schedule (const char * str)
+int sh_suidchk_set_schedule (char * str)
 {
   int status;
@@ -1651,7 +1111,7 @@
 
 
-int sh_suidchk_set_fps (const char * c)
-{
-  volatile long val;
+int sh_suidchk_set_fps (char * c)
+{
+  long val;
 
   SL_ENTER(_("sh_suidchk_set_fps"));
@@ -1659,10 +1119,7 @@
   val = strtol (c, (char **)NULL, 10);
   if (val < 0)
-    {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
-      sh_error_handle ((-1), FIL__, __LINE__, EINVAL, MSG_EINVALS,
-		       _("suidchk fps"), c);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-    }
+    sh_error_handle ((-1), FIL__, __LINE__, EINVAL, MSG_EINVALS,
+                      _("suidchk fps"), c);
+
   val = (val < 0 ? 0 : val);
 
@@ -1671,5 +1128,5 @@
 }
 
-int sh_suidchk_set_yield (const char * c)
+int sh_suidchk_set_yield (char * c)
 {
   int i;
@@ -1684,5 +1141,5 @@
 }
 
-int sh_suidchk_set_activate (const char * c)
+int sh_suidchk_set_activate (char * c)
 {
   int i;
@@ -1692,13 +1149,5 @@
 }
 
-int sh_suidchk_set_nosuid (const char * c)
-{
-  int i;
-  SL_ENTER(_("sh_suidchk_set_nosuid"));
-  i = sh_util_flagval(c, &ShSuidchkNosuid);
-  SL_RETURN(i, _("sh_suidchk_set_nosuid"));
-}
-
-int sh_suidchk_set_quarantine (const char * c)
+int sh_suidchk_set_quarantine (char * c)
 {
   int i;
@@ -1708,5 +1157,5 @@
 }
 
-int sh_suidchk_set_qdelete (const char * c)
+int sh_suidchk_set_qdelete (char * c)
 {
   int i;
@@ -1716,9 +1165,8 @@
 }
 
-int sh_suidchk_set_qmethod (const char * c)
-{
-  volatile long val;
-  volatile int  ret = 0;
-  struct stat buf;
+int sh_suidchk_set_qmethod (char * c)
+{
+  long val;
+  int  ret = 0;
 
   SL_ENTER(_("sh_suidchk_set_qmethod"));
@@ -1727,8 +1175,6 @@
   if (val < 0)
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle ((-1), FIL__, __LINE__, EINVAL, MSG_EINVALS,
 		       _("suidchk qmethod"), c);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
       ret = -1;
     }
@@ -1744,13 +1190,11 @@
           break;
         case SH_Q_MOVE:
-          if (retry_stat (FIL__, __LINE__, DEFAULT_QDIR, &buf) != 0)
+          if (access (DEFAULT_QDIR, F_OK) != 0)
 	    {
 	      if (mkdir (DEFAULT_QDIR, 0750) == -1)
 		{
-		  SH_MUTEX_LOCK(mutex_thread_nolog);
 		  sh_error_handle ((-1), FIL__, __LINE__, EINVAL,
 				   MSG_SUID_ERROR,
 				   _("Unable to create quarantine directory"));
-		  SH_MUTEX_UNLOCK(mutex_thread_nolog);
 		}
 	    }
@@ -1758,8 +1202,6 @@
           break;
         default:
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, EINVAL, MSG_EINVALS,
 			   _("suidchk qmethod"), c);
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
           ShSuidchkQMethod = -1;
 	  ret = -1;
@@ -1938,5 +1380,5 @@
 
 #ifdef FSTYPE_MNTENT		/* 4.3BSD etc.  */
-static int xatoi (const char *cp);
+static int xatoi (char *cp);
 #endif
 
